//+------------------------------------------------------------------+
//|                                                          VDI.mq4 |
//|                                                            tener |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "tener"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1

#property indicator_buffers 5
#property indicator_color1  White
#property indicator_color2  Lime
#property indicator_color3  Red
#property indicator_color4  Green
#property indicator_color5  Green
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  1

extern bool ShowNormalVolume = FALSE;
extern int  Search_Distance = 10;

//---- indicator buffers
double     ExtBuffer1[];
double     ExtBuffer2[];
double     ExtBuffer3[];
double     ExtBuffer4[];
double     ExtBuffer5[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_ARROW);

   SetIndexBuffer(0,ExtBuffer1);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexBuffer(2,ExtBuffer3);
   SetIndexBuffer(3,ExtBuffer4);
   SetIndexBuffer(4,ExtBuffer5);
   SetIndexArrow(4,78);
   
   IndicatorShortName("VDI("+Search_Distance+")");
   SetIndexLabel(0,"Volume");
   IndicatorDigits(0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit,status;
   int counted_bars=IndicatorCounted();
//----
	if (counted_bars>0) counted_bars--;
	limit=Bars-counted_bars;
	
	for (int i=0; i<limit; i++){
		status=0;
		if (iHigh(NULL,0,i)>=iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Search_Distance,i))) status+=1;
		if (iLow(NULL,0,i)<=iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Search_Distance,i)))     status+=2;
		switch(status){
			case 0:  if (ShowNormalVolume) ExtBuffer1[i]=Volume[i]; break;
			case 1:  ExtBuffer2[i]=Volume[i]; break;
			case 2:  ExtBuffer3[i]=Volume[i]; break;
			default: ExtBuffer4[i]=Volume[i]; ExtBuffer5[i]=Volume[i]+(Period()*30); break;
		}
	}
//----
   return(0);
  }
//+------------------------------------------------------------------+